var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var _this = this;
import Vue from 'vue';
import Vuex from 'vuex';
import { VuexListener, Listener } from './plugin';
import _ from 'lodash';
describe('vuex-listener', function () {
    beforeAll(function () {
        Vue.use(Vuex);
        Vue.use(VuexListener);
    });
    beforeEach(function () {
        document.body.innerHTML = "<div id=\"app\"></div>";
    });
    test('$storeListener instance is attached and working in Vue instance', function (done) { return __awaiter(_this, void 0, void 0, function () {
        var beforeActionListener, afterActionListener, mutationListener, store, vm;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    beforeActionListener = jest.fn();
                    afterActionListener = jest.fn();
                    mutationListener = jest.fn();
                    store = new Vuex.Store({
                        state: function () {
                            return {
                                fruits: []
                            };
                        },
                        mutations: {
                            ADD_FRUIT: function (state, _a) {
                                var fruit = _a.fruit;
                                state.fruits.push(fruit.toUpperCase());
                            }
                        },
                        actions: {
                            addFruits: function (context, _a) {
                                var fruits = _a.fruits;
                                fruits.forEach(function (fruit) {
                                    context.commit('ADD_FRUIT', { fruit: fruit });
                                });
                            }
                        }
                    });
                    vm = new Vue({
                        el: '#app',
                        store: store,
                        computed: Vuex.mapState(['fruits']),
                        mounted: function () {
                            this.$storeListener.addBeforeActionListener('addFruits', function (payload, state) {
                                beforeActionListener({
                                    payload: _.cloneDeep(payload),
                                    state: _.cloneDeep(state)
                                });
                            });
                            this.$storeListener.addAfterActionListener('addFruits', function (payload, state) {
                                afterActionListener({
                                    payload: _.cloneDeep(payload),
                                    state: _.cloneDeep(state)
                                });
                            });
                            this.$storeListener.addMutationListener('ADD_FRUIT', function (payload, state) {
                                mutationListener({
                                    payload: _.cloneDeep(payload),
                                    state: _.cloneDeep(state)
                                });
                            });
                        },
                        render: function (h) { return h('div'); }
                    });
                    expect(vm.$storeListener).toBeInstanceOf(Listener);
                    return [4, vm.$store.dispatch('addFruits', {
                            fruits: ['lasŭ', 'sibu']
                        })];
                case 1:
                    _a.sent();
                    expect(beforeActionListener.mock.calls).toEqual([
                        [{ payload: { fruits: ['lasŭ', 'sibu'] }, state: { fruits: [] } }]
                    ]);
                    expect(afterActionListener.mock.calls).toEqual([
                        [{ payload: { fruits: ['lasŭ', 'sibu'] }, state: { fruits: ['LASŬ', 'SIBU'] } }]
                    ]);
                    expect(mutationListener.mock.calls).toEqual([
                        [{ payload: { fruit: 'lasŭ' }, state: { fruits: ['LASŬ'] } }],
                        [{ payload: { fruit: 'sibu' }, state: { fruits: ['LASŬ', 'SIBU'] } }]
                    ]);
                    return [4, vm.$store.dispatch('addFruits', {
                            fruits: ['dihan', 'pi\'an']
                        })];
                case 2:
                    _a.sent();
                    expect(beforeActionListener.mock.calls).toEqual([
                        [{ payload: { fruits: ['lasŭ', 'sibu'] }, state: { fruits: [] } }],
                        [{ payload: { fruits: ['dihan', 'pi\'an'] }, state: { fruits: ['LASŬ', 'SIBU'] } }]
                    ]);
                    expect(afterActionListener.mock.calls).toEqual([
                        [{ payload: { fruits: ['lasŭ', 'sibu'] }, state: { fruits: ['LASŬ', 'SIBU'] } }],
                        [{ payload: { fruits: ['dihan', 'pi\'an'] }, state: { fruits: ['LASŬ', 'SIBU', 'DIHAN', 'PI\'AN'] } }]
                    ]);
                    expect(mutationListener.mock.calls).toEqual([
                        [{ payload: { fruit: 'lasŭ' }, state: { fruits: ['LASŬ'] } }],
                        [{ payload: { fruit: 'sibu' }, state: { fruits: ['LASŬ', 'SIBU'] } }],
                        [{ payload: { fruit: 'dihan' }, state: { fruits: ['LASŬ', 'SIBU', 'DIHAN'] } }],
                        [{ payload: { fruit: 'pi\'an' }, state: { fruits: ['LASŬ', 'SIBU', 'DIHAN', 'PI\'AN'] } }]
                    ]);
                    done();
                    return [2];
            }
        });
    }); });
    test('$storeListener instance is passed to component children', function () {
        var store = new Vuex.Store({});
        var childStoreListener, parentStoreListener;
        var childOptions = {
            mounted: function () {
                childStoreListener = this.$storeListener;
            },
            render: function (h) { return h('span', {}, ['I am the child']); }
        };
        var vm = new Vue({
            el: '#app',
            store: store,
            mounted: function () {
                parentStoreListener = this.$storeListener;
            },
            render: function (h) { return h('div', {}, ['I am the parent', h(childOptions)]); }
        });
        expect(childStoreListener).toBeInstanceOf(Listener);
        expect(childStoreListener).toEqual(parentStoreListener);
    });
    test('$storeListener methods can be unsubscribed', function (done) { return __awaiter(_this, void 0, void 0, function () {
        var beforeActionListener, afterActionListener, mutationListener, beforeActionListenerStays, afterActionListenerStays, mutationListenerStays, store, listener, unsubBeforeActions, unsubAfterActions, unsubMutations;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    beforeActionListener = jest.fn();
                    afterActionListener = jest.fn();
                    mutationListener = jest.fn();
                    beforeActionListenerStays = jest.fn();
                    afterActionListenerStays = jest.fn();
                    mutationListenerStays = jest.fn();
                    store = new Vuex.Store({
                        state: function () {
                            return {
                                distros: []
                            };
                        },
                        mutations: {
                            ADD_DISTRO: function (state, _a) {
                                var distro = _a.distro;
                                state.distros.push(distro + " Linux");
                            }
                        },
                        actions: {
                            addDistros: function (context, _a) {
                                var distros = _a.distros;
                                distros.forEach(function (distro) {
                                    context.commit('ADD_DISTRO', { distro: distro });
                                });
                            }
                        }
                    });
                    listener = new Listener(store);
                    unsubBeforeActions = listener.addBeforeActionListener('addDistros', beforeActionListener);
                    unsubAfterActions = listener.addAfterActionListener('addDistros', afterActionListener);
                    unsubMutations = listener.addMutationListener('ADD_DISTRO', mutationListener);
                    listener.addBeforeActionListener('addDistros', beforeActionListenerStays);
                    listener.addAfterActionListener('addDistros', afterActionListenerStays);
                    listener.addMutationListener('ADD_DISTRO', mutationListenerStays);
                    return [4, store.dispatch('addDistros', { distros: ['Arch', 'Debian', 'Fedora'] })];
                case 1:
                    _a.sent();
                    expect(beforeActionListener).toHaveBeenCalledTimes(1);
                    expect(afterActionListener).toHaveBeenCalledTimes(1);
                    expect(mutationListener).toHaveBeenCalledTimes(3);
                    expect(beforeActionListenerStays).toHaveBeenCalledTimes(1);
                    expect(afterActionListenerStays).toHaveBeenCalledTimes(1);
                    expect(mutationListenerStays).toHaveBeenCalledTimes(3);
                    unsubAfterActions();
                    unsubBeforeActions();
                    unsubMutations();
                    return [4, store.dispatch('addDistros', { distros: ['Kali', 'Trisquel'] })];
                case 2:
                    _a.sent();
                    expect(beforeActionListener).toHaveBeenCalledTimes(1);
                    expect(afterActionListener).toHaveBeenCalledTimes(1);
                    expect(mutationListener).toHaveBeenCalledTimes(3);
                    expect(beforeActionListenerStays).toHaveBeenCalledTimes(2);
                    expect(afterActionListenerStays).toHaveBeenCalledTimes(2);
                    expect(mutationListenerStays).toHaveBeenCalledTimes(5);
                    done();
                    return [2];
            }
        });
    }); });
    test('Listener is invoked lazily', function (done) { return __awaiter(_this, void 0, void 0, function () {
        var store, listener, mutationSubscribe, actionSubscribe, beforeActionListener, afterActionListener, mutationListener;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    store = new Vuex.Store({
                        mutations: { noop: function () { return false; }, oop: function () { return true; } },
                        actions: { noop: function () { return false; }, oop: function () { return true; } }
                    });
                    listener = new Listener(store);
                    mutationSubscribe = jest.spyOn(store, 'subscribe');
                    actionSubscribe = jest.spyOn(store, 'subscribeAction');
                    beforeActionListener = jest.fn();
                    afterActionListener = jest.fn();
                    mutationListener = jest.fn();
                    return [4, store.commit('noop')];
                case 1:
                    _a.sent();
                    return [4, store.dispatch('noop')];
                case 2:
                    _a.sent();
                    expect(mutationSubscribe).toHaveBeenCalledTimes(0);
                    expect(actionSubscribe).toHaveBeenCalledTimes(0);
                    listener.addBeforeActionListener('oop', beforeActionListener);
                    listener.addAfterActionListener('oop', afterActionListener);
                    listener.addMutationListener('oop', mutationListener);
                    expect(mutationSubscribe).toHaveBeenCalledTimes(1);
                    expect(actionSubscribe).toHaveBeenCalledTimes(1);
                    return [4, store.commit('noop')];
                case 3:
                    _a.sent();
                    return [4, store.dispatch('noop')];
                case 4:
                    _a.sent();
                    expect(beforeActionListener).toHaveBeenCalledTimes(0);
                    expect(afterActionListener).toHaveBeenCalledTimes(0);
                    expect(mutationListener).toHaveBeenCalledTimes(0);
                    done();
                    return [2];
            }
        });
    }); });
});
